class Conformer(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  num_features : int
  subsampling_factor : int
  encoder_layers : int
  d_model : int
  cnn_module_kernel : int
  causal : bool
  dynamic_chunk_training : bool
  short_chunk_threshold : float
  short_chunk_size : int
  num_left_chunks : int
  _init_state : List[Tensor]
  encoder_embed : __torch__.conformer.Conv2dSubsampling
  encoder_pos : __torch__.conformer.RelPositionalEncoding
  encoder : __torch__.conformer.ConformerEncoder
  def forward(self: __torch__.conformer.Conformer,
    x: Tensor,
    x_lens: Tensor,
    warmup: float=1.) -> Tuple[Tensor, Tensor]:
    _0 = __torch__.icefall.utils.make_pad_mask
    _1 = "AssertionError: Causal convolution is required for streaming conformer."
    _2 = __torch__.icefall.utils.subsequent_chunk_mask
    encoder_embed = self.encoder_embed
    x0 = (encoder_embed).forward(x, )
    encoder_pos = self.encoder_pos
    x1, pos_emb, = (encoder_pos).forward(x0, 0, )
    x2 = torch.permute(x1, [1, 0, 2])
    _3 = torch.__rshift__(torch.sub(x_lens, 1), 1)
    lengths = torch.__rshift__(torch.sub(_3, 1), 1)
    _4 = torch.eq(torch.size(x2, 0), torch.item(torch.max(lengths)))
    if _4:
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    src_key_padding_mask = _0(lengths, )
    dynamic_chunk_training = self.dynamic_chunk_training
    if dynamic_chunk_training:
      causal = self.causal
      if causal:
        pass
      else:
        ops.prim.RaiseException(_1)
      max_len = torch.size(x2, 0)
      chunk_size = torch.item(torch.randint(1, max_len, [1]))
      short_chunk_threshold = self.short_chunk_threshold
      _5 = torch.mul(max_len, short_chunk_threshold)
      if torch.gt(chunk_size, _5):
        chunk_size0 = max_len
      else:
        short_chunk_size = self.short_chunk_size
        _6 = torch.remainder(chunk_size, short_chunk_size)
        chunk_size0 = torch.add(_6, 1)
      _7 = torch.size(x2, 0)
      num_left_chunks = self.num_left_chunks
      _8 = ops.prim.device(x2)
      _9 = _2(_7, int(chunk_size0), num_left_chunks, _8, )
      mask = torch.bitwise_not(_9)
      encoder = self.encoder
      x4 = (encoder).forward(x2, pos_emb, mask, src_key_padding_mask, warmup, )
      x3 = x4
    else:
      encoder0 = self.encoder
      x5 = (encoder0).forward(x2, pos_emb, None, src_key_padding_mask, warmup, )
      x3 = x5
    x6 = torch.permute(x3, [1, 0, 2])
    return (x6, lengths)
  def get_init_state(self: __torch__.conformer.Conformer,
    left_context: int,
    device: Device) -> List[Tensor]:
    _init_state = self._init_state
    if torch.eq(torch.len(_init_state), 2):
      _init_state0 = self._init_state
      _11 = torch.eq(torch.size(_init_state0[0], 1), left_context)
      _10 = _11
    else:
      _10 = False
    if _10:
      _12 = self._init_state
    else:
      encoder_layers = self.encoder_layers
      d_model = self.d_model
      _13 = [encoder_layers, left_context, d_model]
      _14 = torch.zeros(_13, dtype=None, layout=None, device=device)
      encoder_layers0 = self.encoder_layers
      cnn_module_kernel = self.cnn_module_kernel
      _15 = torch.sub(cnn_module_kernel, 1)
      d_model0 = self.d_model
      _16 = torch.zeros([encoder_layers0, _15, d_model0], dtype=None, layout=None, device=device)
      init_states = [_14, _16]
      self._init_state = init_states
      _12 = init_states
    return _12
  def streaming_forward(self: __torch__.conformer.Conformer,
    x: Tensor,
    x_lens: Tensor,
    states: Optional[List[Tensor]]=None,
    processed_lens: Optional[Tensor]=None,
    left_context: int=64,
    right_context: int=4,
    chunk_size: int=16,
    simulate_streaming: bool=False,
    warmup: float=1.) -> Tuple[Tensor, Tensor, List[Tensor]]:
    _17 = "The length of states MUST be equal to 2, and the shape of\n         first element should be {},\n         given {}. the shape of second element should be\n         {},\n         given {}."
    _18 = __torch__.icefall.utils.make_pad_mask
    _19 = __torch__.icefall.utils.subsequent_chunk_mask
    _20 = uninitialized(Tensor)
    _21 = uninitialized(List[Tensor])
    _22 = torch.__rshift__(torch.sub(x_lens, 1), 1)
    lengths = torch.__rshift__(torch.sub(_22, 1), 1)
    if torch.__not__(simulate_streaming):
      if torch.__isnot__(states, None):
        states2 = unchecked_cast(List[Tensor], states)
        states1 = states2
      else:
        ops.prim.RaiseException("AssertionError: ")
        states1 = _21
      _23 = torch.__isnot__(processed_lens, None)
      if _23:
        processed_lens1 = unchecked_cast(Tensor, processed_lens)
        processed_lens0 = processed_lens1
      else:
        ops.prim.RaiseException("AssertionError: ")
        processed_lens0 = _20
      if torch.eq(torch.len(states1), 2):
        _25 = torch.size(states1[0])
        encoder_layers = self.encoder_layers
        _26 = torch.size(x, 0)
        d_model = self.d_model
        _27 = [encoder_layers, left_context, _26, d_model]
        _24 = torch.eq(_25, _27)
      else:
        _24 = False
      if _24:
        _29 = torch.size(states1[1])
        encoder_layers1 = self.encoder_layers
        cnn_module_kernel = self.cnn_module_kernel
        _30 = torch.sub(cnn_module_kernel, 1)
        _31 = torch.size(x, 0)
        d_model1 = self.d_model
        _32 = [encoder_layers1, _30, _31, d_model1]
        _28 = torch.eq(_29, _32)
      else:
        _28 = False
      if _28:
        pass
      else:
        encoder_layers2 = self.encoder_layers
        _33 = torch.size(x, 0)
        d_model2 = self.d_model
        _34 = (encoder_layers2, left_context, _33, d_model2)
        _35 = torch.size(states1[0])
        encoder_layers3 = self.encoder_layers
        cnn_module_kernel0 = self.cnn_module_kernel
        _36 = torch.sub(cnn_module_kernel0, 1)
        _37 = torch.size(x, 0)
        d_model3 = self.d_model
        _38 = (encoder_layers3, _36, _37, d_model3)
        _39 = torch.format(_17, _34, _35, _38, torch.size(states1[1]))
        _40 = torch.add("AssertionError: ", _39)
        ops.prim.RaiseException(_40)
      lengths1 = torch.sub_(lengths, 2)
      src_key_padding_mask = _18(lengths1, )
      _41 = torch.arange(left_context, dtype=None, layout=None, device=ops.prim.device(x))
      processed_mask = torch.expand(_41, [torch.size(x, 0), left_context])
      processed_lens2 = torch.view(processed_lens0, [torch.size(x, 0), 1])
      _42 = torch.le(processed_lens2, processed_mask)
      processed_mask0 = torch.flip(_42, [1])
      _43 = [processed_mask0, src_key_padding_mask]
      src_key_padding_mask0 = torch.cat(_43, 1)
      encoder_embed = self.encoder_embed
      embed = (encoder_embed).forward(x, )
      _44 = torch.slice(torch.slice(embed), 1, 1, -1)
      embed0 = torch.slice(_44, 2)
      encoder_pos = self.encoder_pos
      _45 = (encoder_pos).forward(embed0, left_context, )
      embed1, pos_enc, = _45
      embed2 = torch.permute(embed1, [1, 0, 2])
      encoder = self.encoder
      _46 = (encoder).chunk_forward(embed2, pos_enc, states1, None, src_key_padding_mask0, warmup, left_context, right_context, )
      x8, states3, = _46
      if torch.gt(right_context, 0):
        x10 = torch.slice(x8, 0, 0, torch.neg(right_context))
        lengths3 = torch.sub_(lengths1, right_context)
        x9, lengths2 = x10, lengths3
      else:
        x9, lengths2 = x8, lengths1
      x7, lengths0, states0 = x9, lengths2, states3
    else:
      if torch.__is__(states, None):
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
      _47 = annotate(List[Tensor], [])
      src_key_padding_mask1 = _18(lengths, )
      encoder_embed0 = self.encoder_embed
      x11 = (encoder_embed0).forward(x, )
      encoder_pos0 = self.encoder_pos
      x12, pos_emb, = (encoder_pos0).forward(x11, 0, )
      x13 = torch.permute(x12, [1, 0, 2])
      _48 = torch.eq(torch.size(x13, 0), torch.item(torch.max(lengths)))
      if _48:
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
      if torch.ge(left_context, 0):
        _49 = torch.remainder(left_context, chunk_size)
        if torch.eq(_49, 0):
          pass
        else:
          ops.prim.RaiseException("AssertionError: ")
        num_left_chunks0 = torch.floordiv(left_context, chunk_size)
        num_left_chunks = num_left_chunks0
      else:
        num_left_chunks = -1
      _50 = _19(torch.size(x13, 0), chunk_size, num_left_chunks, ops.prim.device(x13), )
      mask = torch.bitwise_not(_50)
      encoder1 = self.encoder
      x14 = (encoder1).forward(x13, pos_emb, mask, src_key_padding_mask1, warmup, )
      x7, lengths0, states0 = x14, lengths, _47
    x15 = torch.permute(x7, [1, 0, 2])
    return (x15, lengths0, states0)
class Conv2dSubsampling(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  conv : __torch__.torch.nn.modules.container.Sequential
  out : __torch__.scaling.ScaledLinear
  out_norm : __torch__.scaling.BasicNorm
  out_balancer : __torch__.scaling.ActivationBalancer
  def forward(self: __torch__.conformer.Conv2dSubsampling,
    x: Tensor) -> Tensor:
    x16 = torch.unsqueeze(x, 1)
    conv = self.conv
    x17 = (conv).forward(x16, )
    b, c, t, f, = torch.size(x17)
    out = self.out
    _51 = torch.contiguous(torch.transpose(x17, 1, 2))
    _52 = torch.view(_51, [b, t, torch.mul(c, f)])
    x18 = (out).forward(_52, )
    out_norm = self.out_norm
    x19 = (out_norm).forward(x18, )
    out_balancer = self.out_balancer
    return (out_balancer).forward(x19, )
class RelPositionalEncoding(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  d_model : int
  pe : Tensor
  dropout : __torch__.torch.nn.modules.dropout.Dropout
  def forward(self: __torch__.conformer.RelPositionalEncoding,
    x: Tensor,
    left_context: int=0) -> Tuple[Tensor, Tensor]:
    _53 = (self).extend_pe(x, left_context, )
    x_size_1 = torch.add(torch.size(x, 1), left_context)
    pe = self.pe
    _54 = torch.slice(pe)
    pe0 = self.pe
    _55 = torch.floordiv(torch.size(pe0, 1), 2)
    _56 = torch.add(torch.sub(_55, x_size_1), 1)
    pe1 = self.pe
    _57 = torch.floordiv(torch.size(pe1, 1), 2)
    pos_emb = torch.slice(_54, 1, _56, torch.add(_57, torch.size(x, 1)))
    dropout = self.dropout
    _58 = (dropout).forward(x, )
    dropout0 = self.dropout
    _59 = (_58, (dropout0).forward(pos_emb, ))
    return _59
  def extend_pe(self: __torch__.conformer.RelPositionalEncoding,
    x: Tensor,
    left_context: int=0) -> NoneType:
    x_size_1 = torch.add(torch.size(x, 1), left_context)
    pe = self.pe
    _60 = torch.size(pe, 1)
    _61 = torch.sub(torch.mul(x_size_1, 2), 1)
    if torch.ge(_60, _61):
      pe2 = self.pe
      _62 = torch.ne(ops.prim.dtype(pe2), ops.prim.dtype(x))
      if _62:
        _63 = True
      else:
        pe3 = self.pe
        _64 = torch.ne(str(ops.prim.device(pe3)), str(ops.prim.device(x)))
        _63 = _64
      if _63:
        pe4 = self.pe
        _65 = ops.prim.dtype(x)
        _66 = torch.to(pe4, ops.prim.device(x), _65)
        self.pe = _66
      else:
        pass
    else:
      d_model = self.d_model
      pe_positive = torch.zeros([x_size_1, d_model])
      d_model4 = self.d_model
      pe_negative = torch.zeros([x_size_1, d_model4])
      _67 = torch.arange(0, x_size_1, dtype=6)
      position = torch.unsqueeze(_67, 1)
      d_model5 = self.d_model
      _68 = torch.arange(0, d_model5, 2, dtype=6)
      d_model6 = self.d_model
      _69 = torch.div(9.2103403719761836, d_model6)
      div_term = torch.exp(torch.mul(_68, torch.neg(_69)))
      _70 = torch.sin(torch.mul(position, div_term))
      _71 = torch.slice(torch.slice(pe_positive), 1, 0, None, 2)
      _72 = torch.copy_(_71, _70)
      _73 = torch.cos(torch.mul(position, div_term))
      _74 = torch.slice(torch.slice(pe_positive), 1, 1, None, 2)
      _75 = torch.copy_(_74, _73)
      _76 = torch.mul(torch.mul(position, -1), div_term)
      _77 = torch.sin(_76)
      _78 = torch.slice(torch.slice(pe_negative), 1, 0, None, 2)
      _79 = torch.copy_(_78, _77)
      _80 = torch.mul(torch.mul(position, -1), div_term)
      _81 = torch.cos(_80)
      _82 = torch.slice(torch.slice(pe_negative), 1, 1, None, 2)
      _83 = torch.copy_(_82, _81)
      pe_positive0 = torch.unsqueeze(torch.flip(pe_positive, [0]), 0)
      pe_negative0 = torch.unsqueeze(torch.slice(pe_negative, 0, 1), 0)
      pe5 = torch.cat([pe_positive0, pe_negative0], 1)
      _84 = torch.to(pe5, ops.prim.device(x), ops.prim.dtype(x))
      self.pe = _84
    return None
class ConformerEncoder(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  num_layers : int
  aux_layers : List[int]
  layers : __torch__.torch.nn.modules.container.ModuleList
  combiner : __torch__.conformer.RandomCombine
  def forward(self: __torch__.conformer.ConformerEncoder,
    src: Tensor,
    pos_emb: Tensor,
    mask: Optional[Tensor]=None,
    src_key_padding_mask: Optional[Tensor]=None,
    warmup: float=1.) -> Tensor:
    _85 = annotate(List[Tensor], [])
    layers = self.layers
    _0 = getattr(layers, "0")
    _1 = getattr(layers, "1")
    _2 = getattr(layers, "2")
    _3 = getattr(layers, "3")
    _4 = getattr(layers, "4")
    _5 = getattr(layers, "5")
    _6 = getattr(layers, "6")
    _7 = getattr(layers, "7")
    _8 = getattr(layers, "8")
    _9 = getattr(layers, "9")
    _10 = getattr(layers, "10")
    _11 = getattr(layers, "11")
    _12 = getattr(layers, "12")
    _13 = getattr(layers, "13")
    _14 = getattr(layers, "14")
    _15 = getattr(layers, "15")
    _16 = getattr(layers, "16")
    _17 = getattr(layers, "17")
    output = (_0).forward(src, pos_emb, mask, src_key_padding_mask, warmup, )
    aux_layers = self.aux_layers
    if torch.__contains__(aux_layers, 0):
      _86 = torch.append(_85, output)
    else:
      pass
    output0 = (_1).forward(output, pos_emb, mask, src_key_padding_mask, warmup, )
    aux_layers0 = self.aux_layers
    if torch.__contains__(aux_layers0, 1):
      _87 = torch.append(_85, output0)
    else:
      pass
    output1 = (_2).forward(output0, pos_emb, mask, src_key_padding_mask, warmup, )
    aux_layers1 = self.aux_layers
    if torch.__contains__(aux_layers1, 2):
      _88 = torch.append(_85, output1)
    else:
      pass
    output2 = (_3).forward(output1, pos_emb, mask, src_key_padding_mask, warmup, )
    aux_layers2 = self.aux_layers
    if torch.__contains__(aux_layers2, 3):
      _89 = torch.append(_85, output2)
    else:
      pass
    output3 = (_4).forward(output2, pos_emb, mask, src_key_padding_mask, warmup, )
    aux_layers3 = self.aux_layers
    if torch.__contains__(aux_layers3, 4):
      _90 = torch.append(_85, output3)
    else:
      pass
    output4 = (_5).forward(output3, pos_emb, mask, src_key_padding_mask, warmup, )
    aux_layers4 = self.aux_layers
    if torch.__contains__(aux_layers4, 5):
      _91 = torch.append(_85, output4)
    else:
      pass
    output5 = (_6).forward(output4, pos_emb, mask, src_key_padding_mask, warmup, )
    aux_layers5 = self.aux_layers
    if torch.__contains__(aux_layers5, 6):
      _92 = torch.append(_85, output5)
    else:
      pass
    output6 = (_7).forward(output5, pos_emb, mask, src_key_padding_mask, warmup, )
    aux_layers6 = self.aux_layers
    if torch.__contains__(aux_layers6, 7):
      _93 = torch.append(_85, output6)
    else:
      pass
    output7 = (_8).forward(output6, pos_emb, mask, src_key_padding_mask, warmup, )
    aux_layers7 = self.aux_layers
    if torch.__contains__(aux_layers7, 8):
      _94 = torch.append(_85, output7)
    else:
      pass
    output8 = (_9).forward(output7, pos_emb, mask, src_key_padding_mask, warmup, )
    aux_layers8 = self.aux_layers
    if torch.__contains__(aux_layers8, 9):
      _95 = torch.append(_85, output8)
    else:
      pass
    output9 = (_10).forward(output8, pos_emb, mask, src_key_padding_mask, warmup, )
    aux_layers9 = self.aux_layers
    if torch.__contains__(aux_layers9, 10):
      _96 = torch.append(_85, output9)
    else:
      pass
    output10 = (_11).forward(output9, pos_emb, mask, src_key_padding_mask, warmup, )
    aux_layers10 = self.aux_layers
    _97 = torch.__contains__(aux_layers10, 11)
    if _97:
      _98 = torch.append(_85, output10)
    else:
      pass
    output11 = (_12).forward(output10, pos_emb, mask, src_key_padding_mask, warmup, )
    aux_layers11 = self.aux_layers
    _99 = torch.__contains__(aux_layers11, 12)
    if _99:
      _100 = torch.append(_85, output11)
    else:
      pass
    output12 = (_13).forward(output11, pos_emb, mask, src_key_padding_mask, warmup, )
    aux_layers12 = self.aux_layers
    _101 = torch.__contains__(aux_layers12, 13)
    if _101:
      _102 = torch.append(_85, output12)
    else:
      pass
    output13 = (_14).forward(output12, pos_emb, mask, src_key_padding_mask, warmup, )
    aux_layers13 = self.aux_layers
    _103 = torch.__contains__(aux_layers13, 14)
    if _103:
      _104 = torch.append(_85, output13)
    else:
      pass
    output14 = (_15).forward(output13, pos_emb, mask, src_key_padding_mask, warmup, )
    aux_layers14 = self.aux_layers
    _105 = torch.__contains__(aux_layers14, 15)
    if _105:
      _106 = torch.append(_85, output14)
    else:
      pass
    output15 = (_16).forward(output14, pos_emb, mask, src_key_padding_mask, warmup, )
    aux_layers15 = self.aux_layers
    _107 = torch.__contains__(aux_layers15, 16)
    if _107:
      _108 = torch.append(_85, output15)
    else:
      pass
    output16 = (_17).forward(output15, pos_emb, mask, src_key_padding_mask, warmup, )
    aux_layers16 = self.aux_layers
    _109 = torch.__contains__(aux_layers16, 17)
    if _109:
      _110 = torch.append(_85, output16)
    else:
      pass
    combiner = self.combiner
    return (combiner).forward(_85, )
  def chunk_forward(self: __torch__.conformer.ConformerEncoder,
    src: Tensor,
    pos_emb: Tensor,
    states: List[Tensor],
    mask: Optional[Tensor]=None,
    src_key_padding_mask: Optional[Tensor]=None,
    warmup: float=1.,
    left_context: int=0,
    right_context: int=0) -> Tuple[Tensor, List[Tensor]]:
    training = self.training
    if torch.__not__(training):
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    if torch.eq(torch.len(states), 2):
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    _111 = torch.size(states[0])
    num_layers = self.num_layers
    _112 = [num_layers, left_context, torch.size(src, 1), torch.size(src, 2)]
    if torch.eq(_111, _112):
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    _113 = torch.size(states[1], 0)
    num_layers0 = self.num_layers
    if torch.eq(_113, num_layers0):
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    layers = self.layers
    _0 = getattr(layers, "0")
    _1 = getattr(layers, "1")
    _2 = getattr(layers, "2")
    _3 = getattr(layers, "3")
    _4 = getattr(layers, "4")
    _5 = getattr(layers, "5")
    _6 = getattr(layers, "6")
    _7 = getattr(layers, "7")
    _8 = getattr(layers, "8")
    _9 = getattr(layers, "9")
    _10 = getattr(layers, "10")
    _11 = getattr(layers, "11")
    _12 = getattr(layers, "12")
    _13 = getattr(layers, "13")
    _14 = getattr(layers, "14")
    _15 = getattr(layers, "15")
    _16 = getattr(layers, "16")
    _17 = getattr(layers, "17")
    cache = [torch.select(states[0], 0, 0), torch.select(states[1], 0, 0)]
    _114 = (_0).chunk_forward(src, pos_emb, cache, mask, src_key_padding_mask, warmup, left_context, right_context, )
    output, cache0, = _114
    _115 = cache0[0]
    _116 = torch.copy_(torch.select(states[0], 0, 0), _115)
    _117 = cache0[1]
    _118 = torch.copy_(torch.select(states[1], 0, 0), _117)
    cache1 = [torch.select(states[0], 0, 1), torch.select(states[1], 0, 1)]
    _119 = (_1).chunk_forward(output, pos_emb, cache1, mask, src_key_padding_mask, warmup, left_context, right_context, )
    output17, cache2, = _119
    _120 = cache2[0]
    _121 = torch.copy_(torch.select(states[0], 0, 1), _120)
    _122 = cache2[1]
    _123 = torch.copy_(torch.select(states[1], 0, 1), _122)
    cache3 = [torch.select(states[0], 0, 2), torch.select(states[1], 0, 2)]
    _124 = (_2).chunk_forward(output17, pos_emb, cache3, mask, src_key_padding_mask, warmup, left_context, right_context, )
    output18, cache4, = _124
    _125 = cache4[0]
    _126 = torch.copy_(torch.select(states[0], 0, 2), _125)
    _127 = cache4[1]
    _128 = torch.copy_(torch.select(states[1], 0, 2), _127)
    cache5 = [torch.select(states[0], 0, 3), torch.select(states[1], 0, 3)]
    _129 = (_3).chunk_forward(output18, pos_emb, cache5, mask, src_key_padding_mask, warmup, left_context, right_context, )
    output19, cache6, = _129
    _130 = cache6[0]
    _131 = torch.copy_(torch.select(states[0], 0, 3), _130)
    _132 = cache6[1]
    _133 = torch.copy_(torch.select(states[1], 0, 3), _132)
    cache7 = [torch.select(states[0], 0, 4), torch.select(states[1], 0, 4)]
    _134 = (_4).chunk_forward(output19, pos_emb, cache7, mask, src_key_padding_mask, warmup, left_context, right_context, )
    output20, cache8, = _134
    _135 = cache8[0]
    _136 = torch.copy_(torch.select(states[0], 0, 4), _135)
    _137 = cache8[1]
    _138 = torch.copy_(torch.select(states[1], 0, 4), _137)
    cache9 = [torch.select(states[0], 0, 5), torch.select(states[1], 0, 5)]
    _139 = (_5).chunk_forward(output20, pos_emb, cache9, mask, src_key_padding_mask, warmup, left_context, right_context, )
    output21, cache10, = _139
    _140 = cache10[0]
    _141 = torch.copy_(torch.select(states[0], 0, 5), _140)
    _142 = cache10[1]
    _143 = torch.copy_(torch.select(states[1], 0, 5), _142)
    cache11 = [torch.select(states[0], 0, 6), torch.select(states[1], 0, 6)]
    _144 = (_6).chunk_forward(output21, pos_emb, cache11, mask, src_key_padding_mask, warmup, left_context, right_context, )
    output22, cache12, = _144
    _145 = cache12[0]
    _146 = torch.copy_(torch.select(states[0], 0, 6), _145)
    _147 = cache12[1]
    _148 = torch.copy_(torch.select(states[1], 0, 6), _147)
    cache13 = [torch.select(states[0], 0, 7), torch.select(states[1], 0, 7)]
    _149 = (_7).chunk_forward(output22, pos_emb, cache13, mask, src_key_padding_mask, warmup, left_context, right_context, )
    output23, cache14, = _149
    _150 = cache14[0]
    _151 = torch.copy_(torch.select(states[0], 0, 7), _150)
    _152 = cache14[1]
    _153 = torch.copy_(torch.select(states[1], 0, 7), _152)
    cache15 = [torch.select(states[0], 0, 8), torch.select(states[1], 0, 8)]
    _154 = (_8).chunk_forward(output23, pos_emb, cache15, mask, src_key_padding_mask, warmup, left_context, right_context, )
    output24, cache16, = _154
    _155 = cache16[0]
    _156 = torch.copy_(torch.select(states[0], 0, 8), _155)
    _157 = cache16[1]
    _158 = torch.copy_(torch.select(states[1], 0, 8), _157)
    cache17 = [torch.select(states[0], 0, 9), torch.select(states[1], 0, 9)]
    _159 = (_9).chunk_forward(output24, pos_emb, cache17, mask, src_key_padding_mask, warmup, left_context, right_context, )
    output25, cache18, = _159
    _160 = cache18[0]
    _161 = torch.copy_(torch.select(states[0], 0, 9), _160)
    _162 = cache18[1]
    _163 = torch.copy_(torch.select(states[1], 0, 9), _162)
    cache19 = [torch.select(states[0], 0, 10), torch.select(states[1], 0, 10)]
    _164 = (_10).chunk_forward(output25, pos_emb, cache19, mask, src_key_padding_mask, warmup, left_context, right_context, )
    output26, cache20, = _164
    _165 = cache20[0]
    _166 = torch.copy_(torch.select(states[0], 0, 10), _165)
    _167 = cache20[1]
    _168 = torch.copy_(torch.select(states[1], 0, 10), _167)
    cache21 = [torch.select(states[0], 0, 11), torch.select(states[1], 0, 11)]
    _169 = (_11).chunk_forward(output26, pos_emb, cache21, mask, src_key_padding_mask, warmup, left_context, right_context, )
    output27, cache22, = _169
    _170 = cache22[0]
    _171 = torch.copy_(torch.select(states[0], 0, 11), _170)
    _172 = cache22[1]
    _173 = torch.copy_(torch.select(states[1], 0, 11), _172)
    cache23 = [torch.select(states[0], 0, 12), torch.select(states[1], 0, 12)]
    _174 = (_12).chunk_forward(output27, pos_emb, cache23, mask, src_key_padding_mask, warmup, left_context, right_context, )
    output28, cache24, = _174
    _175 = cache24[0]
    _176 = torch.copy_(torch.select(states[0], 0, 12), _175)
    _177 = cache24[1]
    _178 = torch.copy_(torch.select(states[1], 0, 12), _177)
    cache25 = [torch.select(states[0], 0, 13), torch.select(states[1], 0, 13)]
    _179 = (_13).chunk_forward(output28, pos_emb, cache25, mask, src_key_padding_mask, warmup, left_context, right_context, )
    output29, cache26, = _179
    _180 = cache26[0]
    _181 = torch.copy_(torch.select(states[0], 0, 13), _180)
    _182 = cache26[1]
    _183 = torch.copy_(torch.select(states[1], 0, 13), _182)
    cache27 = [torch.select(states[0], 0, 14), torch.select(states[1], 0, 14)]
    _184 = (_14).chunk_forward(output29, pos_emb, cache27, mask, src_key_padding_mask, warmup, left_context, right_context, )
    output30, cache28, = _184
    _185 = cache28[0]
    _186 = torch.copy_(torch.select(states[0], 0, 14), _185)
    _187 = cache28[1]
    _188 = torch.copy_(torch.select(states[1], 0, 14), _187)
    cache29 = [torch.select(states[0], 0, 15), torch.select(states[1], 0, 15)]
    _189 = (_15).chunk_forward(output30, pos_emb, cache29, mask, src_key_padding_mask, warmup, left_context, right_context, )
    output31, cache30, = _189
    _190 = cache30[0]
    _191 = torch.copy_(torch.select(states[0], 0, 15), _190)
    _192 = cache30[1]
    _193 = torch.copy_(torch.select(states[1], 0, 15), _192)
    cache31 = [torch.select(states[0], 0, 16), torch.select(states[1], 0, 16)]
    _194 = (_16).chunk_forward(output31, pos_emb, cache31, mask, src_key_padding_mask, warmup, left_context, right_context, )
    output32, cache32, = _194
    _195 = cache32[0]
    _196 = torch.copy_(torch.select(states[0], 0, 16), _195)
    _197 = cache32[1]
    _198 = torch.copy_(torch.select(states[1], 0, 16), _197)
    cache33 = [torch.select(states[0], 0, 17), torch.select(states[1], 0, 17)]
    _199 = (_17).chunk_forward(output32, pos_emb, cache33, mask, src_key_padding_mask, warmup, left_context, right_context, )
    output33, cache34, = _199
    _200 = cache34[0]
    _201 = torch.copy_(torch.select(states[0], 0, 17), _200)
    _202 = cache34[1]
    _203 = torch.copy_(torch.select(states[1], 0, 17), _202)
    return (output33, states)
class ConformerEncoderLayer(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  layer_dropout : float
  d_model : int
  self_attn : __torch__.conformer.RelPositionMultiheadAttention
  feed_forward : __torch__.torch.nn.modules.container.___torch_mangle_7.Sequential
  feed_forward_macaron : __torch__.torch.nn.modules.container.___torch_mangle_7.Sequential
  conv_module : __torch__.conformer.ConvolutionModule
  norm_final : __torch__.scaling.___torch_mangle_10.BasicNorm
  balancer : __torch__.scaling.ActivationBalancer
  dropout : __torch__.torch.nn.modules.dropout.Dropout
  def forward(self: __torch__.conformer.ConformerEncoderLayer,
    src: Tensor,
    pos_emb: Tensor,
    src_mask: Optional[Tensor]=None,
    src_key_padding_mask: Optional[Tensor]=None,
    warmup: float=1.) -> Tensor:
    _204 = torch.add(0.10000000000000001, warmup)
    warmup_scale = ops.prim.min(_204, 1.)
    training = self.training
    if training:
      _205 = torch.rand(annotate(List[int], []))
      _206 = torch.item(_205)
      layer_dropout = self.layer_dropout
      _207 = torch.le(_206, torch.sub(1., layer_dropout))
      if _207:
        alpha0 = warmup_scale
      else:
        alpha0 = 0.10000000000000001
      alpha = alpha0
    else:
      alpha = 1.
    dropout = self.dropout
    feed_forward_macaron = self.feed_forward_macaron
    _208 = (feed_forward_macaron).forward(src, )
    src0 = torch.add(src, (dropout).forward(_208, ))
    self_attn = self.self_attn
    _209 = (self_attn).forward(src0, src0, src0, pos_emb, src_key_padding_mask, True, src_mask, 0, )
    src_att = (_209)[0]
    dropout1 = self.dropout
    src1 = torch.add(src0, (dropout1).forward(src_att, ))
    conv_module = self.conv_module
    _210 = (conv_module).forward(src1, None, 0, )
    conv, _211, = _210
    dropout2 = self.dropout
    src2 = torch.add(src1, (dropout2).forward(conv, ))
    dropout3 = self.dropout
    feed_forward = self.feed_forward
    _212 = (dropout3).forward((feed_forward).forward(src2, ), )
    src3 = torch.add(src2, _212)
    norm_final = self.norm_final
    balancer = self.balancer
    src4 = (norm_final).forward((balancer).forward(src3, ), )
    if torch.ne(alpha, 1.):
      _213 = torch.mul(src4, alpha)
      _214 = torch.mul(src, torch.sub(1, alpha))
      src5 = torch.add(_213, _214)
    else:
      src5 = src4
    return src5
  def chunk_forward(self: __torch__.conformer.ConformerEncoderLayer,
    src: Tensor,
    pos_emb: Tensor,
    states: List[Tensor],
    src_mask: Optional[Tensor]=None,
    src_key_padding_mask: Optional[Tensor]=None,
    warmup: float=1.,
    left_context: int=0,
    right_context: int=0) -> Tuple[Tensor, List[Tensor]]:
    training = self.training
    if torch.__not__(training):
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    if torch.eq(torch.len(states), 2):
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    _215 = torch.size(states[0])
    _216 = [left_context, torch.size(src, 1), torch.size(src, 2)]
    if torch.eq(_215, _216):
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    dropout = self.dropout
    feed_forward_macaron = self.feed_forward_macaron
    _217 = (feed_forward_macaron).forward(src, )
    src6 = torch.add(src, (dropout).forward(_217, ))
    key = torch.cat([states[0], src6])
    if torch.gt(right_context, 0):
      _218 = torch.add(left_context, right_context)
      _219 = torch.slice(key, 0, torch.neg(_218), torch.neg(right_context))
      _220 = torch._set_item(states, 0, _219)
    else:
      _221 = torch.slice(key, 0, torch.neg(left_context))
      _222 = torch._set_item(states, 0, _221)
    self_attn = self.self_attn
    _223 = (self_attn).forward(src6, key, key, pos_emb, src_key_padding_mask, True, src_mask, left_context, )
    src_att = (_223)[0]
    dropout4 = self.dropout
    src7 = torch.add(src6, (dropout4).forward(src_att, ))
    conv_module = self.conv_module
    _224 = (conv_module).forward(src7, states[1], right_context, )
    conv, conv_cache, = _224
    _225 = torch._set_item(states, 1, conv_cache)
    dropout5 = self.dropout
    src8 = torch.add(src7, (dropout5).forward(conv, ))
    dropout6 = self.dropout
    feed_forward = self.feed_forward
    _226 = (dropout6).forward((feed_forward).forward(src8, ), )
    src9 = torch.add(src8, _226)
    norm_final = self.norm_final
    balancer = self.balancer
    src10 = (norm_final).forward((balancer).forward(src9, ), )
    return (src10, states)
class RelPositionMultiheadAttention(Module):
  __parameters__ = ["pos_bias_u", "pos_bias_v", "pos_bias_u_scale", "pos_bias_v_scale", ]
  __buffers__ = []
  pos_bias_u : Tensor
  pos_bias_v : Tensor
  pos_bias_u_scale : Tensor
  pos_bias_v_scale : Tensor
  training : bool
  _is_full_backward_hook : Optional[bool]
  embed_dim : int
  num_heads : int
  dropout : float
  head_dim : int
  in_proj : __torch__.scaling.___torch_mangle_2.ScaledLinear
  out_proj : __torch__.scaling.___torch_mangle_3.ScaledLinear
  linear_pos : __torch__.scaling.___torch_mangle_4.ScaledLinear
  def forward(self: __torch__.conformer.RelPositionMultiheadAttention,
    query: Tensor,
    key: Tensor,
    value: Tensor,
    pos_emb: Tensor,
    key_padding_mask: Optional[Tensor]=None,
    need_weights: bool=True,
    attn_mask: Optional[Tensor]=None,
    left_context: int=0) -> Tuple[Tensor, Optional[Tensor]]:
    embed_dim = self.embed_dim
    num_heads = self.num_heads
    in_proj = self.in_proj
    _227 = (in_proj).get_weight()
    in_proj0 = self.in_proj
    _228 = (in_proj0).get_bias()
    dropout = self.dropout
    out_proj = self.out_proj
    _229 = (out_proj).get_weight()
    out_proj0 = self.out_proj
    _230 = (out_proj0).get_bias()
    training = self.training
    _231 = (self).multi_head_attention_forward(query, key, value, pos_emb, embed_dim, num_heads, _227, _228, dropout, _229, _230, training, key_padding_mask, need_weights, attn_mask, left_context, )
    return _231
  def multi_head_attention_forward(self: __torch__.conformer.RelPositionMultiheadAttention,
    query: Tensor,
    key: Tensor,
    value: Tensor,
    pos_emb: Tensor,
    embed_dim_to_check: int,
    num_heads: int,
    in_proj_weight: Tensor,
    in_proj_bias: Tensor,
    dropout_p: float,
    out_proj_weight: Tensor,
    out_proj_bias: Tensor,
    training: bool=True,
    key_padding_mask: Optional[Tensor]=None,
    need_weights: bool=True,
    attn_mask: Optional[Tensor]=None,
    left_context: int=0) -> Tuple[Tensor, Optional[Tensor]]:
    _232 = "AssertionError: embed_dim must be divisible by num_heads"
    _233 = "Only float, byte, and bool types are supported for attn_mask, not {}"
    _234 = "Byte tensor for attn_mask is deprecated. Use bool tensor instead."
    _235 = "The size of the 2D attn_mask is not correct."
    _236 = "The size of the 3D attn_mask is not correct."
    _237 = "attn_mask\'s dimension {} is not supported"
    _238 = "Byte tensor for key_padding_mask is deprecated. Use bool tensor instead."
    _239 = __torch__.torch.nn.functional.softmax
    _240 = __torch__.torch.nn.functional.dropout
    tgt_len, bsz, embed_dim, = torch.size(query)
    _241 = torch.eq(embed_dim, embed_dim_to_check)
    if _241:
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    _242 = torch.eq(torch.size(key, 0), torch.size(value, 0))
    if _242:
      _244 = torch.eq(torch.size(key, 1), torch.size(value, 1))
      _243 = _244
    else:
      _243 = False
    if _243:
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    head_dim = torch.floordiv(embed_dim, num_heads)
    _245 = torch.eq(torch.mul(head_dim, num_heads), embed_dim)
    if _245:
      pass
    else:
      ops.prim.RaiseException(_232)
    scaling = torch.pow(float(head_dim), -0.5)
    if torch.equal(query, key):
      _246 = torch.equal(key, value)
    else:
      _246 = False
    if _246:
      _247 = torch.linear(query, in_proj_weight, in_proj_bias)
      q0, k0, v0, = torch.chunk(_247, 3, -1)
      q, k, v = q0, k0, v0
    else:
      if torch.equal(key, value):
        _248 = torch.slice(in_proj_weight, 0, 0, embed_dim)
        _w = torch.slice(_248, 1)
        _b = torch.slice(in_proj_bias, 0, 0, embed_dim)
        q2 = torch.linear(query, _w, _b)
        _249 = torch.slice(in_proj_weight, 0, embed_dim)
        _w0 = torch.slice(_249, 1)
        _b0 = torch.slice(in_proj_bias, 0, embed_dim)
        _250 = torch.chunk(torch.linear(key, _w0, _b0), 2, -1)
        k2, v2, = _250
        q1, k1, v1 = q2, k2, v2
      else:
        _251 = torch.slice(in_proj_weight, 0, 0, embed_dim)
        _w1 = torch.slice(_251, 1)
        _b1 = torch.slice(in_proj_bias, 0, 0, embed_dim)
        q3 = torch.linear(query, _w1, _b1)
        _end = torch.mul(embed_dim, 2)
        _252 = torch.slice(in_proj_weight, 0, embed_dim, _end)
        _w2 = torch.slice(_252, 1)
        _b2 = torch.slice(in_proj_bias, 0, embed_dim, _end)
        k3 = torch.linear(key, _w2, _b2)
        _start = torch.mul(embed_dim, 2)
        _253 = torch.slice(in_proj_weight, 0, _start)
        _w3 = torch.slice(_253, 1)
        _b3 = torch.slice(in_proj_bias, 0, _start)
        q1, k1, v1 = q3, k3, torch.linear(value, _w3, _b3)
      q, k, v = q1, k1, v1
    if torch.__isnot__(attn_mask, None):
      attn_mask1 = unchecked_cast(Tensor, attn_mask)
      _254 = torch.eq(ops.prim.dtype(attn_mask1), 6)
      if _254:
        _255 = True
      else:
        _256 = torch.eq(ops.prim.dtype(attn_mask1), 7)
        _255 = _256
      if _255:
        _257 = True
      else:
        _258 = torch.eq(ops.prim.dtype(attn_mask1), 5)
        _257 = _258
      if _257:
        _259 = True
      else:
        _260 = torch.eq(ops.prim.dtype(attn_mask1), 0)
        _259 = _260
      if _259:
        _261 = True
      else:
        _262 = torch.eq(ops.prim.dtype(attn_mask1), 11)
        _261 = _262
      if _261:
        pass
      else:
        _263 = torch.format(_233, ops.prim.dtype(attn_mask1))
        _264 = torch.add("AssertionError: ", _263)
        ops.prim.RaiseException(_264)
      _265 = torch.eq(ops.prim.dtype(attn_mask1), 0)
      if _265:
        torch.warn(_234)
        attn_mask2 = torch.to(attn_mask1, 11)
      else:
        attn_mask2 = attn_mask1
      _266 = torch.eq(torch.dim(attn_mask2), 2)
      if _266:
        attn_mask4 = torch.unsqueeze(attn_mask2, 0)
        _267 = torch.list(torch.size(attn_mask4))
        _268 = [1, torch.size(query, 0), torch.size(key, 0)]
        if torch.ne(_267, _268):
          ops.prim.RaiseException(_235, "builtins.RuntimeError")
        else:
          pass
        attn_mask3 = attn_mask4
      else:
        _269 = torch.eq(torch.dim(attn_mask2), 3)
        if _269:
          _270 = torch.list(torch.size(attn_mask2))
          _271 = [torch.mul(bsz, num_heads), torch.size(query, 0), torch.size(key, 0)]
          if torch.ne(_270, _271):
            ops.prim.RaiseException(_236, "builtins.RuntimeError")
          else:
            pass
        else:
          _272 = torch.format(_237, torch.dim(attn_mask2))
          ops.prim.RaiseException(_272, "builtins.RuntimeError")
        attn_mask3 = attn_mask2
      attn_mask0 : Optional[Tensor] = attn_mask3
    else:
      attn_mask0 = attn_mask
    _273 = torch.__isnot__(key_padding_mask, None)
    if _273:
      key_padding_mask1 = unchecked_cast(Tensor, key_padding_mask)
      _275 = torch.eq(ops.prim.dtype(key_padding_mask1), 0)
      _274, key_padding_mask0 = _275, key_padding_mask1
    else:
      _274, key_padding_mask0 = False, key_padding_mask
    if _274:
      key_padding_mask3 = unchecked_cast(Tensor, key_padding_mask0)
      torch.warn(_238)
      key_padding_mask2 : Optional[Tensor] = torch.to(key_padding_mask3, 11)
    else:
      key_padding_mask2 = key_padding_mask0
    _276 = torch.contiguous(torch.mul(q, scaling))
    q4 = torch.view(_276, [tgt_len, bsz, num_heads, head_dim])
    k4 = torch.view(torch.contiguous(k), [-1, bsz, num_heads, head_dim])
    _277 = torch.contiguous(v)
    _278 = [-1, torch.mul(bsz, num_heads), head_dim]
    v3 = torch.transpose(torch.view(_277, _278), 0, 1)
    src_len = torch.size(k4, 0)
    _279 = torch.__isnot__(key_padding_mask2, None)
    if _279:
      key_padding_mask5 = unchecked_cast(Tensor, key_padding_mask2)
      _280 = torch.eq(torch.size(key_padding_mask5, 0), bsz)
      if _280:
        pass
      else:
        _281 = torch.size(key_padding_mask5, 0)
        _282 = torch.format("{} == {}", _281, bsz)
        _283 = torch.add("AssertionError: ", _282)
        ops.prim.RaiseException(_283)
      _284 = torch.eq(torch.size(key_padding_mask5, 1), src_len)
      if _284:
        pass
      else:
        _285 = torch.size(key_padding_mask5, 1)
        _286 = torch.format("{} == {}", _285, src_len)
        _287 = torch.add("AssertionError: ", _286)
        ops.prim.RaiseException(_287)
      key_padding_mask4 : Optional[Tensor] = key_padding_mask5
    else:
      key_padding_mask4 = key_padding_mask2
    q5 = torch.transpose(q4, 0, 1)
    pos_emb_bsz = torch.size(pos_emb, 0)
    _288 = torch.__contains__([1, bsz], pos_emb_bsz)
    if _288:
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    linear_pos = self.linear_pos
    _289 = (linear_pos).forward(pos_emb, )
    _290 = [pos_emb_bsz, -1, num_heads, head_dim]
    p = torch.view(_289, _290)
    p0 = torch.permute(p, [0, 2, 3, 1])
    q_with_bias_u = torch.transpose(torch.add(q5, (self)._pos_bias_u()), 1, 2)
    q_with_bias_v = torch.transpose(torch.add(q5, (self)._pos_bias_v()), 1, 2)
    k5 = torch.permute(k4, [1, 2, 3, 0])
    matrix_ac = torch.matmul(q_with_bias_u, k5)
    matrix_bd = torch.matmul(q_with_bias_v, p0)
    matrix_bd0 = (self).rel_shift(matrix_bd, left_context, )
    attn_output_weights = torch.add(matrix_ac, matrix_bd0)
    _291 = [torch.mul(bsz, num_heads), tgt_len, -1]
    attn_output_weights0 = torch.view(attn_output_weights, _291)
    _292 = torch.list(torch.size(attn_output_weights0))
    _293 = [torch.mul(bsz, num_heads), tgt_len, src_len]
    if torch.eq(_292, _293):
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    if torch.__isnot__(attn_mask0, None):
      attn_mask6 = unchecked_cast(Tensor, attn_mask0)
      _294 = torch.eq(ops.prim.dtype(attn_mask6), 11)
      if _294:
        _295 = torch.masked_fill_(attn_output_weights0, attn_mask6, -inf)
        attn_output_weights2 = attn_output_weights0
      else:
        attn_output_weights3 = torch.add_(attn_output_weights0, attn_mask6)
        attn_output_weights2 = attn_output_weights3
      attn_output_weights1, attn_mask5 = attn_output_weights2, attn_mask6
    else:
      attn_output_weights1, attn_mask5 = attn_output_weights0, attn_mask0
    _296 = torch.__isnot__(key_padding_mask4, None)
    if _296:
      key_padding_mask7 = unchecked_cast(Tensor, key_padding_mask4)
      _297 = [bsz, num_heads, tgt_len, src_len]
      attn_output_weights5 = torch.view(attn_output_weights1, _297)
      _298 = torch.unsqueeze(key_padding_mask7, 1)
      attn_output_weights6 = torch.masked_fill(attn_output_weights5, torch.unsqueeze(_298, 2), -inf)
      _299 = [torch.mul(bsz, num_heads), tgt_len, src_len]
      attn_output_weights7 = torch.view(attn_output_weights6, _299)
      attn_output_weights4, key_padding_mask6 = attn_output_weights7, key_padding_mask7
    else:
      attn_output_weights4, key_padding_mask6 = attn_output_weights1, key_padding_mask4
    attn_output_weights8 = _239(attn_output_weights4, -1, 3, None, )
    if torch.__isnot__(attn_mask5, None):
      attn_mask8 = unchecked_cast(Tensor, attn_mask5)
      _301 = torch.eq(ops.prim.dtype(attn_mask8), 11)
      _300, attn_mask7 = _301, attn_mask8
    else:
      _300, attn_mask7 = False, attn_mask5
    if _300:
      attn_mask10 = unchecked_cast(Tensor, attn_mask7)
      _303 = torch.__isnot__(key_padding_mask6, None)
      _302, attn_mask9 = _303, attn_mask10
    else:
      _302, attn_mask9 = False, attn_mask7
    if _302:
      attn_mask11 = unchecked_cast(Tensor, attn_mask9)
      key_padding_mask8 = unchecked_cast(Tensor, key_padding_mask6)
      _304 = torch.ne(torch.size(attn_mask11, 0), 1)
      if _304:
        _305 = [bsz, num_heads, tgt_len, src_len]
        attn_mask12 = torch.view(attn_mask11, _305)
        _306 = torch.unsqueeze(key_padding_mask8, 1)
        combined_mask0 = torch.__or__(attn_mask12, torch.unsqueeze(_306, 2))
        combined_mask = combined_mask0
      else:
        _307 = torch.unsqueeze(attn_mask11, 0)
        _308 = torch.unsqueeze(key_padding_mask8, 1)
        combined_mask1 = torch.__or__(_307, torch.unsqueeze(_308, 2))
        combined_mask = combined_mask1
      _309 = [bsz, num_heads, tgt_len, src_len]
      attn_output_weights10 = torch.view(attn_output_weights8, _309)
      attn_output_weights11 = torch.masked_fill(attn_output_weights10, combined_mask, 0.)
      _310 = [torch.mul(bsz, num_heads), tgt_len, src_len]
      attn_output_weights12 = torch.view(attn_output_weights11, _310)
      attn_output_weights9 = attn_output_weights12
    else:
      attn_output_weights9 = attn_output_weights8
    attn_output_weights13 = _240(attn_output_weights9, dropout_p, training, False, )
    attn_output = torch.bmm(attn_output_weights13, v3)
    _311 = torch.list(torch.size(attn_output))
    _312 = [torch.mul(bsz, num_heads), tgt_len, head_dim]
    if torch.eq(_311, _312):
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    _313 = torch.contiguous(torch.transpose(attn_output, 0, 1))
    attn_output0 = torch.view(_313, [tgt_len, bsz, embed_dim])
    attn_output1 = torch.linear(attn_output0, out_proj_weight, out_proj_bias)
    if need_weights:
      _315 = [bsz, num_heads, tgt_len, src_len]
      attn_output_weights14 = torch.view(attn_output_weights13, _315)
      _316 = torch.sum(attn_output_weights14, [1])
      _317 = (attn_output1, torch.div(_316, num_heads))
      _314 = _317
    else:
      _314 = (attn_output1, None)
    return _314
  def _pos_bias_u(self: __torch__.conformer.RelPositionMultiheadAttention) -> Tensor:
    pos_bias_u = self.pos_bias_u
    pos_bias_u_scale = self.pos_bias_u_scale
    _318 = torch.mul(pos_bias_u, torch.exp(pos_bias_u_scale))
    return _318
  def _pos_bias_v(self: __torch__.conformer.RelPositionMultiheadAttention) -> Tensor:
    pos_bias_v = self.pos_bias_v
    pos_bias_v_scale = self.pos_bias_v_scale
    _319 = torch.mul(pos_bias_v, torch.exp(pos_bias_v_scale))
    return _319
  def rel_shift(self: __torch__.conformer.RelPositionMultiheadAttention,
    x: Tensor,
    left_context: int=0) -> Tensor:
    batch_size, num_heads, time1, n, = torch.size(x)
    time2 = torch.add(time1, left_context)
    _320 = torch.add(left_context, torch.mul(2, time1))
    if torch.eq(n, torch.sub(_320, 1)):
      pass
    else:
      _321 = torch.format("{} == {} + 2 * {} - 1", n, left_context, time1)
      _322 = torch.add("AssertionError: ", _321)
      ops.prim.RaiseException(_322)
    batch_stride = torch.stride(x, 0)
    head_stride = torch.stride(x, 1)
    time1_stride = torch.stride(x, 2)
    n_stride = torch.stride(x, 3)
    _323 = torch.sub(time1_stride, n_stride)
    _324 = torch.mul(n_stride, torch.sub(time1, 1))
    _325 = [batch_size, num_heads, time1, time2]
    _326 = [batch_stride, head_stride, _323, n_stride]
    _327 = torch.as_strided(x, _325, _326, _324)
    return _327
class ConvolutionModule(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  causal : bool
  lorder : int
  pointwise_conv1 : __torch__.scaling.ScaledConv1d
  deriv_balancer1 : __torch__.scaling.ActivationBalancer
  depthwise_conv : __torch__.scaling.___torch_mangle_8.ScaledConv1d
  deriv_balancer2 : __torch__.scaling.ActivationBalancer
  activation : __torch__.scaling.DoubleSwish
  pointwise_conv2 : __torch__.scaling.___torch_mangle_9.ScaledConv1d
  def forward(self: __torch__.conformer.ConvolutionModule,
    x: Tensor,
    cache: Optional[Tensor]=None,
    right_context: int=0) -> Tuple[Tensor, Tensor]:
    _328 = "AssertionError: Cache should be None in training time"
    x20 = torch.permute(x, [1, 2, 0])
    pointwise_conv1 = self.pointwise_conv1
    x21 = (pointwise_conv1).forward(x20, )
    deriv_balancer1 = self.deriv_balancer1
    x22 = (deriv_balancer1).forward(x21, )
    x23 = __torch__.torch.nn.functional.glu(x22, 1, )
    causal = self.causal
    if causal:
      lorder = self.lorder
      _329 = torch.gt(lorder, 0)
    else:
      _329 = False
    if _329:
      if torch.__is__(cache, None):
        lorder0 = self.lorder
        x26 = torch.pad(x23, [lorder0, 0], "constant", 0.)
        x25, cache36 = x26, cache
      else:
        cache37 = unchecked_cast(Tensor, cache)
        training = self.training
        if torch.__not__(training):
          pass
        else:
          ops.prim.RaiseException(_328)
        _330 = torch.size(cache37, 0)
        lorder1 = self.lorder
        if torch.eq(_330, lorder1):
          pass
        else:
          ops.prim.RaiseException("AssertionError: ")
        _331 = torch.permute(cache37, [1, 2, 0])
        x27 = torch.cat([_331, x23], 2)
        if torch.gt(right_context, 0):
          _332 = torch.permute(x27, [2, 0, 1])
          lorder2 = self.lorder
          _333 = torch.add(lorder2, right_context)
          cache39 = torch.slice(_332, 0, torch.neg(_333), torch.neg(right_context))
          cache38 = cache39
        else:
          _334 = torch.permute(x27, [2, 0, 1])
          lorder3 = self.lorder
          cache40 = torch.slice(_334, 0, torch.neg(lorder3))
          cache38 = cache40
        x25, cache36 = x27, cache38
      x24, cache35 = x25, cache36
    else:
      x24, cache35 = x23, cache
    depthwise_conv = self.depthwise_conv
    x28 = (depthwise_conv).forward(x24, )
    deriv_balancer2 = self.deriv_balancer2
    x29 = (deriv_balancer2).forward(x28, )
    activation = self.activation
    x30 = (activation).forward(x29, )
    pointwise_conv2 = self.pointwise_conv2
    x31 = (pointwise_conv2).forward(x30, )
    if torch.__is__(cache35, None):
      cache41 = torch.empty([0])
    else:
      cache41 = unchecked_cast(Tensor, cache35)
    _335 = (torch.permute(x31, [2, 0, 1]), cache41)
    return _335
class RandomCombine(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  num_inputs : int
  final_weight : float
  pure_prob : float
  stddev : float
  final_log_weight : float
  def forward(self: __torch__.conformer.RandomCombine,
    inputs: List[Tensor]) -> Tensor:
    num_inputs = self.num_inputs
    _336 = torch.eq(torch.len(inputs), num_inputs)
    if _336:
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    return inputs[-1]
