class ScaledConv2d(Module):
  __parameters__ = ["weight", "bias", "weight_scale", "bias_scale", ]
  __buffers__ = []
  weight : Tensor
  bias : Optional[Tensor]
  weight_scale : Tensor
  bias_scale : Tensor
  training : bool
  _is_full_backward_hook : NoneType
  transposed : bool
  _reversed_padding_repeated_twice : List[int]
  output_padding : Final[Tuple[int, int]] = (0, 0)
  kernel_size : Final[Tuple[int, int]] = (3, 3)
  dilation : Final[Tuple[int, int]] = (1, 1)
  stride : Final[Tuple[int, int]] = (1, 1)
  in_channels : Final[int] = 1
  padding_mode : Final[str] = "zeros"
  groups : Final[int] = 1
  out_channels : Final[int] = 8
  padding : Final[Tuple[int, int]] = (1, 1)
  def forward(self: __torch__.scaling.ScaledConv2d,
    input: Tensor) -> Tensor:
    _0 = (self)._conv_forward(input, (self).get_weight(), )
    return _0
  def _conv_forward(self: __torch__.scaling.ScaledConv2d,
    input: Tensor,
    weight: Tensor) -> Tensor:
    _1 = torch.conv2d(input, weight, (self).get_bias(), [1, 1], [1, 1], [1, 1])
    return _1
  def get_bias(self: __torch__.scaling.ScaledConv2d) -> Optional[Tensor]:
    bias = self.bias
    bias_scale = self.bias_scale
    if torch.__is__(bias, None):
      _2 : Optional[Tensor] = None
    else:
      bias0 = unchecked_cast(Tensor, bias)
      bias1 = unchecked_cast(Tensor, bias0)
      _3 = torch.mul(bias1, torch.exp(bias_scale))
      _2 = _3
    return _2
  def get_weight(self: __torch__.scaling.ScaledConv2d) -> Tensor:
    weight = self.weight
    weight_scale = self.weight_scale
    _4 = torch.mul(weight, torch.exp(weight_scale))
    return _4
class ActivationBalancer(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  channel_dim : int
  min_positive : float
  max_positive : float
  max_factor : float
  min_abs : float
  max_abs : float
  def forward(self: __torch__.scaling.ActivationBalancer,
    x: Tensor) -> Tensor:
    return x
class DoubleSwish(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  def forward(self: __torch__.scaling.DoubleSwish,
    x: Tensor) -> Tensor:
    _5 = torch.mul(x, torch.sigmoid(torch.sub(x, 1.)))
    return _5
class ScaledLinear(Module):
  __parameters__ = ["weight", "bias", "weight_scale", "bias_scale", ]
  __buffers__ = []
  weight : Tensor
  bias : Tensor
  weight_scale : Tensor
  bias_scale : Tensor
  training : bool
  _is_full_backward_hook : NoneType
  out_features : Final[int] = 256
  in_features : Final[int] = 2432
  def forward(self: __torch__.scaling.ScaledLinear,
    input: Tensor) -> Tensor:
    _6 = torch.linear(input, (self).get_weight(), (self).get_bias())
    return _6
  def get_weight(self: __torch__.scaling.ScaledLinear) -> Tensor:
    weight = self.weight
    weight_scale = self.weight_scale
    _7 = torch.mul(weight, torch.exp(weight_scale))
    return _7
  def get_bias(self: __torch__.scaling.ScaledLinear) -> Tensor:
    bias = self.bias
    bias_scale = self.bias_scale
    _8 = torch.mul(bias, torch.exp(bias_scale))
    return _8
class BasicNorm(Module):
  __parameters__ = []
  __buffers__ = ["eps", ]
  eps : Tensor
  training : bool
  _is_full_backward_hook : Optional[bool]
  num_channels : int
  channel_dim : int
  def forward(self: __torch__.scaling.BasicNorm,
    x: Tensor) -> Tensor:
    _9 = __torch__.icefall.utils.is_jit_tracing
    if torch.__not__(_9()):
      _10 = torch.size(x)
      channel_dim = self.channel_dim
      _11 = _10[channel_dim]
      num_channels = self.num_channels
      if torch.eq(_11, num_channels):
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
    else:
      pass
    _12 = torch.pow(x, 2)
    channel_dim0 = self.channel_dim
    _13 = torch.mean(_12, [channel_dim0], True)
    eps = self.eps
    scales = torch.pow(torch.add(_13, torch.exp(eps)), -0.5)
    return torch.mul(x, scales)
class ScaledConv1d(Module):
  __parameters__ = ["weight", "bias", "weight_scale", "bias_scale", ]
  __buffers__ = []
  weight : Tensor
  bias : Optional[Tensor]
  weight_scale : Tensor
  bias_scale : Tensor
  training : bool
  _is_full_backward_hook : NoneType
  transposed : bool
  _reversed_padding_repeated_twice : List[int]
  output_padding : Final[Tuple[int]] = (0,)
  kernel_size : Final[Tuple[int]] = (1,)
  dilation : Final[Tuple[int]] = (1,)
  stride : Final[Tuple[int]] = (1,)
  in_channels : Final[int] = 256
  padding_mode : Final[str] = "zeros"
  groups : Final[int] = 1
  out_channels : Final[int] = 512
  padding : Final[Tuple[int]] = (0,)
  def forward(self: __torch__.scaling.ScaledConv1d,
    input: Tensor) -> Tensor:
    _14 = torch.conv1d(input, (self).get_weight(), (self).get_bias(), [1], [0], [1])
    return _14
  def get_weight(self: __torch__.scaling.ScaledConv1d) -> Tensor:
    weight = self.weight
    weight_scale = self.weight_scale
    _15 = torch.mul(weight, torch.exp(weight_scale))
    return _15
  def get_bias(self: __torch__.scaling.ScaledConv1d) -> Optional[Tensor]:
    bias = self.bias
    bias_scale = self.bias_scale
    if torch.__is__(bias, None):
      _16 : Optional[Tensor] = None
    else:
      bias2 = unchecked_cast(Tensor, bias)
      bias3 = unchecked_cast(Tensor, bias2)
      _17 = torch.mul(bias3, torch.exp(bias_scale))
      _16 = _17
    return _16
class ScaledEmbedding(Module):
  __parameters__ = ["scale", "weight", ]
  __buffers__ = []
  scale : Tensor
  weight : Tensor
  training : bool
  _is_full_backward_hook : NoneType
  padding_idx : Final[int] = 0
  scale_grad_by_freq : Final[bool] = False
  sparse : Final[bool] = False
  num_embeddings : Final[int] = 250
  embedding_dim : Final[int] = 512
  def forward(self: __torch__.scaling.ScaledEmbedding,
    input: Tensor) -> Tensor:
    _18 = __torch__.torch.nn.functional.embedding
    scale = self.scale
    scale0 = torch.exp(scale)
    if torch.lt(torch.numel(input), 250):
      weight = self.weight
      _20 = _18(input, weight, 0, None, 2., False, False, )
      _19 = torch.mul(_20, scale0)
    else:
      weight0 = self.weight
      _21 = _18(input, torch.mul(weight0, scale0), 0, None, 2., False, False, )
      _19 = _21
    return _19
