class ScaledConv2d(Module):
  __parameters__ = ["weight", "bias", "weight_scale", "bias_scale", ]
  __buffers__ = []
  weight : Tensor
  bias : Optional[Tensor]
  weight_scale : Tensor
  bias_scale : Tensor
  training : bool
  _is_full_backward_hook : NoneType
  transposed : bool
  _reversed_padding_repeated_twice : List[int]
  output_padding : Final[Tuple[int, int]] = (0, 0)
  kernel_size : Final[Tuple[int, int]] = (3, 3)
  dilation : Final[Tuple[int, int]] = (1, 1)
  stride : Final[Tuple[int, int]] = (2, 2)
  in_channels : Final[int] = 32
  padding_mode : Final[str] = "zeros"
  groups : Final[int] = 1
  out_channels : Final[int] = 128
  padding : Final[Tuple[int, int]] = (0, 0)
  def forward(self: __torch__.scaling.___torch_mangle_1.ScaledConv2d,
    input: Tensor) -> Tensor:
    _0 = (self)._conv_forward(input, (self).get_weight(), )
    return _0
  def _conv_forward(self: __torch__.scaling.___torch_mangle_1.ScaledConv2d,
    input: Tensor,
    weight: Tensor) -> Tensor:
    _1 = torch.conv2d(input, weight, (self).get_bias(), [2, 2], [0, 0], [1, 1])
    return _1
  def get_bias(self: __torch__.scaling.___torch_mangle_1.ScaledConv2d) -> Optional[Tensor]:
    bias = self.bias
    bias_scale = self.bias_scale
    if torch.__is__(bias, None):
      _2 : Optional[Tensor] = None
    else:
      bias0 = unchecked_cast(Tensor, bias)
      bias1 = unchecked_cast(Tensor, bias0)
      _3 = torch.mul(bias1, torch.exp(bias_scale))
      _2 = _3
    return _2
  def get_weight(self: __torch__.scaling.___torch_mangle_1.ScaledConv2d) -> Tensor:
    weight = self.weight
    weight_scale = self.weight_scale
    _4 = torch.mul(weight, torch.exp(weight_scale))
    return _4
