def dropout(input: Tensor,
    p: float=0.5,
    training: bool=True,
    inplace: bool=False) -> Tensor:
  _0 = "dropout probability has to be between 0 and 1, but got {}"
  if torch.lt(p, 0.):
    _1 = True
  else:
    _1 = torch.gt(p, 1.)
  if _1:
    ops.prim.RaiseException(torch.format(_0, p), "builtins.ValueError")
  else:
    pass
  if inplace:
    _2 = torch.dropout_(input, p, training)
  else:
    _2 = torch.dropout(input, p, training)
  return _2
def softmax(input: Tensor,
    dim: Optional[int]=None,
    _stacklevel: int=3,
    dtype: Optional[int]=None) -> Tensor:
  _3 = __torch__.torch.nn.functional._get_softmax_dim
  if torch.__is__(dim, None):
    dim1 = _3("softmax", torch.dim(input), _stacklevel, )
    dim0 = dim1
  else:
    dim0 = unchecked_cast(int, dim)
  if torch.__is__(dtype, None):
    ret = torch.softmax(input, dim0)
  else:
    dtype0 = unchecked_cast(int, dtype)
    ret = torch.softmax(input, dim0, dtype0)
  return ret
def glu(input: Tensor,
    dim: int=-1) -> Tensor:
  _4 = "glu does not support scalars because halving size must be even"
  if torch.eq(torch.dim(input), 0):
    ops.prim.RaiseException(_4, "builtins.RuntimeError")
  else:
    pass
  return torch.glu(input, dim)
def relu(input: Tensor,
    inplace: bool=False) -> Tensor:
  if inplace:
    result = torch.relu_(input)
  else:
    result = torch.relu(input)
  return result
def embedding(input: Tensor,
    weight: Tensor,
    padding_idx: Optional[int]=None,
    max_norm: Optional[float]=None,
    norm_type: float=2.,
    scale_grad_by_freq: bool=False,
    sparse: bool=False) -> Tensor:
  _5 = "AssertionError: Padding_idx must be within num_embeddings"
  if torch.__isnot__(padding_idx, None):
    padding_idx1 = unchecked_cast(int, padding_idx)
    if torch.gt(padding_idx1, 0):
      _6 = torch.lt(padding_idx1, torch.size(weight, 0))
      if _6:
        pass
      else:
        ops.prim.RaiseException(_5)
      padding_idx2 = padding_idx1
    else:
      if torch.lt(padding_idx1, 0):
        _7 = torch.neg(torch.size(weight, 0))
        if torch.ge(padding_idx1, _7):
          pass
        else:
          ops.prim.RaiseException(_5)
        padding_idx4 = torch.add(torch.size(weight, 0), padding_idx1)
        padding_idx3 = padding_idx4
      else:
        padding_idx3 = padding_idx1
      padding_idx2 = padding_idx3
    padding_idx0 = padding_idx2
  else:
    padding_idx0 = -1
  if torch.__isnot__(max_norm, None):
    input0 = torch.contiguous(input)
  else:
    input0 = input
  _8 = torch.embedding(weight, input0, padding_idx0, scale_grad_by_freq, sparse)
  return _8
def _get_softmax_dim(name: str,
    ndim: int,
    stacklevel: int) -> int:
  _9 = "Implicit dimension choice for {} has been deprecated. Change the call to include dim=X as an argument."
  torch.warn(torch.format(_9, name), stacklevel)
  if torch.eq(ndim, 0):
    _10 = True
  else:
    _10 = torch.eq(ndim, 1)
  if _10:
    _11 = True
  else:
    _11 = torch.eq(ndim, 3)
  if _11:
    ret = 0
  else:
    ret = 1
  return ret
